Bug 810336 - Review Request: ga - Global Arrays Toolkit
Review Request: ga - Global Arrays Toolkit
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-04-05 11:48 EDT by David Brown
Modified: 2014-07-07 23:44 EDT (History)
5 users (show)

See Also:
Fixed In Version: ga-5.1.1-3.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-05-31 23:26:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description David Brown 2012-04-05 11:48:52 EDT
Spec URL: http://dmlb2000.homelinux.org/packages/ga.spec
SRPM URL: http://dmlb2000.homelinux.org/packages/ga-5.1-1.f18.src.rpm
Description: 
The Global Arrays (GA) toolkit provides an efficient and portable
"shared-memory" programming interface for distributed-memory
computers. Each process in a MIMD parallel program can asynchronously
access logical blocks of physically distributed dense multi-
dimensional arrays, without need for explicit cooperation by other
processes. Unlike other shared-memory environments, the GA model
exposes to the programmer the non-uniform memory access (NUMA)
characteristics of the high performance computers and acknowledges
that access to a remote portion of the shared data is slower than to
the local portion. The locality information for the shared data is
available, and a direct access to the local portions of shared data
is provided.
Comment 1 David Brown 2012-04-05 11:51:26 EDT
Since I don't have a package already in there I'll need to get a sponsor for this one. 

Also, this is licensed with a Battelle License that's BSD like so it'd be nice if someone from fedora legal could look at it and check it off as being okay.
Comment 2 Susi Lehtola 2012-04-06 11:06:20 EDT
If you need BLAS or LAPACK, please use ATLAS instead of the reference versions, since it's way faster.

**

 --bindir=%{_libdir}/$MPI_COMPILER_NAME/bin
should read
 --bindir=$MPI_BIN

and the same for MPI_LIB and MPI_INCLUDE.
Comment 3 David Brown 2012-04-06 11:23:07 EDT
So I noticed there were several versions of atlas with different instruction sets built with each. Should I just depend on atlas or pick the sse3 variant? or is it my choice?
Comment 4 David Brown 2012-04-06 11:55:18 EDT
Also, I had a question about the build process. Currently the GA build for OpenMPI requires an infiniband network, since the communication layer under GA doesn't have the concept of dynamically linking in the communication layer or building all possible communication layers and dynamically choosing one at runtime.

Also, the kernel.shmmax sysctl value needs to change in order for the tests to run successfully to completion.

So I have some doubts as to running the make check for both mpich2 and openmpi working consistently on the build systems fedora uses.

Thoughts?

I could at runtime in the spec determine if you have an infiniband stack and then run the openmpi tests. I could do the same for the shmmax value.

Or should I just chuck the make checks to decomplicate the spec?
Comment 5 David Brown 2012-04-06 17:13:08 EDT
I've updated the ga.spec and src rpm respectively. Please redownload from the urls in the original ticket.
Comment 6 Susi Lehtola 2012-04-06 20:24:48 EDT
(In reply to comment #3)
> So I noticed there were several versions of atlas with different instruction
> sets built with each. Should I just depend on atlas or pick the sse3 variant?
> or is it my choice?

You BuildRequires: atlas-devel, and rpm will automatically pick up any relevant requires since the libraries will be linked in.
Comment 7 David Brown 2012-04-09 17:53:11 EDT
I've run rpmlint in the resulting rpms from mock and cleaned up quite a bit of cruft from the original ga.spec so please check it out again.

Thanks.
Comment 8 Jason Tibbitts 2012-07-05 15:14:55 EDT
I went to look but I only see the original links.  If you updated the package, can you provide fresh links?
Comment 9 David Brown 2012-07-05 15:38:30 EDT
Yeah the link is busted should be fc18 not f18.
Comment 10 Jason Tibbitts 2012-07-05 16:36:53 EDT
What I'm saying is that if you updated the package, then you should have increased the Release: tag and generated a new srpm and we're going to need a link to that one.  The spec link above still shows 5.1-1 so I guess you didn't upload the new package or something.
Comment 11 David Brown 2012-07-05 18:27:46 EDT
Yes, I've not looked at this in a while I was going back and reviewing the spec and package to make sure its got things I've learned since posting this in place.

changelog entry release bump are just a few. I'm also curious about the tests. I've got a %check in there but I don't want to break any of the build boxes by running them.

There's also an error about licencing that I need to fix. Something about an out of date GPL license for something, iirc. I've made upstream aware of the situation they just don't seem interested in fixing it right away.
Comment 12 Jason Tibbitts 2012-07-05 18:30:46 EDT
Generally you do want to run checks if possible.  Why do you think you would break the build boxes by running them?

About the license, you're probably seeing something about an outdated address for the FSF.  It is true that they moved some time ago, and that upstreams should update their license files everywhere to reflect the new address.  However, this isn't something you're expected to fix.
Comment 13 David Brown 2012-07-05 18:33:01 EDT
GA was built and designed to be run on large top500.org sized computers. So they don't play nice when crammed onto something tiny and the tests may fail because of that.
Comment 14 David Brown 2012-07-05 19:20:24 EDT
Okay updated package http://dmlb2000.homelinux.org/packages/ga-5.1-2.fc17.src.rpm

I removed the tests since they require that kernel.shmmax be > the default provided with fedora so that the build can happen without changes to the building system.
Comment 15 Thomas Spura 2012-07-08 13:54:44 EDT
Sponsored in bug #810010, removing FE-NEEDSPONSOR.
Comment 16 David Brown 2012-07-15 00:17:37 EDT
If someone's looked at this and okay'ed it could you please set the fedora-review flag?
Comment 17 David Brown 2012-07-17 00:13:43 EDT
http://dmlb2000.homelinux.org/packages/ga.spec

original spec file has been updated to reflect the new version.
Comment 18 David Brown 2012-07-17 01:01:15 EDT
I updated to get rid of a lot of the warnings.

http://dmlb2000.homelinux.org/packages/ga-5.1-3.fc17.src.rpm


$ rpmlint /var/lib/mock/fedora-rawhide-x86_64/result/*.rpm
ga.src: E: specfile-error doBuild: invalid option -- '-'
ga.src: E: specfile-error error: Unknown option ? in doBuild()
ga-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/ga-5.1/ga-5.1-openmpi/armci/src/include/tas-i386.h
ga-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/ga-5.1/ga-5.1-mpich2/armci/src/include/tas-i386.h
ga-mpich2-devel.x86_64: W: only-non-binary-in-usr-lib
ga-openmpi-devel.x86_64: W: only-non-binary-in-usr-lib
9 packages and 0 specfiles checked; 4 errors, 2 warnings.
$

The errors about the doBuild thing are kinda weird its in reference to the argument I pass as --with-openib. Its not an error in shell that's perfectly acceptable, and the build happens just fine. So I'm not sure what I'm doing 'wrong' with it spitting out an error like that.

The incorrect fsf address I can't really do anything about upstream has been made aware of it.

The warnings about non-binary in usr-lib are for the ga-config scripts that are supposed to be in the MPI_ROOT/bin directory.
Comment 19 Jason Tibbitts 2013-05-01 21:48:26 EDT
I am triaging old review tickets.  I can't promise a review if you reply, but by closing out the stale tickets we can devote extra attention to the ones which aren't stale.

Links appear to be invalid; I cannot resolve the hostname.
Comment 20 David Brown 2013-05-02 01:48:42 EDT
I've updated the package to fedora 20 I'd like to have a review but haven't found someone to do that yet.

http://dmlb2000.dyndns.org/packages/ga.spec
http://dmlb2000.dyndns.org/packages/ga-5.1.1-1.fc20.src.rpm

$ rpmlint /var/lib/mock/fedora-rawhide-i386/result/ga-*.rpm
ga.src: W: spelling-error %description -l en_US multi -> mulch, mufti
ga.src: E: specfile-error doBuild: invalid option -- '-'
ga.src: E: specfile-error error: Unknown option - in doBuild()
ga-common.noarch: W: spelling-error %description -l en_US multi -> mulch, mufti
ga-mpich2.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
ga-mpich2-devel.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
ga-mpich2-devel.i686: W: only-non-binary-in-usr-lib
ga-mpich2-static.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
ga-openmpi.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
ga-openmpi-devel.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
ga-openmpi-devel.i686: W: only-non-binary-in-usr-lib
ga-openmpi-static.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
9 packages and 0 specfiles checked; 2 errors, 10 warnings.
Comment 21 Mario Blättermann 2013-05-10 16:22:07 EDT
I'll do the final review.
Comment 22 Mario Blättermann 2013-05-10 17:08:54 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5362983

$ rpmlint -i -v *
ga.src: I: checking
ga.src: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga.src: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga.src: E: specfile-error doBuild: invalid option -- '-'
This error occurred when rpmlint used rpm to query the specfile.  The error is
output by rpm and the message should contain more information.

ga.src: E: specfile-error error: Unknown option - in doBuild()
This error occurred when rpmlint used rpm to query the specfile.  The error is
output by rpm and the message should contain more information.

ga-common.noarch: I: checking
ga-common.noarch: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-common.noarch: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-debuginfo.i686: I: checking
ga-debuginfo.i686: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-debuginfo.x86_64: I: checking
ga-debuginfo.x86_64: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-mpich2.i686: I: checking
ga-mpich2.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-mpich2.i686: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-mpich2.x86_64: I: checking
ga-mpich2.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-mpich2.x86_64: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-mpich2-devel.i686: I: checking
ga-mpich2-devel.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-mpich2-devel.i686: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-mpich2-devel.i686: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

ga-mpich2-devel.x86_64: I: checking
ga-mpich2-devel.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-mpich2-devel.x86_64: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-mpich2-devel.x86_64: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

ga-mpich2-static.i686: I: checking
ga-mpich2-static.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-mpich2-static.i686: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-mpich2-static.x86_64: I: checking
ga-mpich2-static.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-mpich2-static.x86_64: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-openmpi.i686: I: checking
ga-openmpi.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-openmpi.i686: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-openmpi.x86_64: I: checking
ga-openmpi.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-openmpi.x86_64: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-openmpi-devel.i686: I: checking
ga-openmpi-devel.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-openmpi-devel.i686: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-openmpi-devel.i686: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

ga-openmpi-devel.x86_64: I: checking
ga-openmpi-devel.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-openmpi-devel.x86_64: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-openmpi-devel.x86_64: W: only-non-binary-in-usr-lib
There are only non binary files in /usr/lib so they should be in /usr/share.

ga-openmpi-static.i686: I: checking
ga-openmpi-static.i686: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-openmpi-static.i686: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga-openmpi-static.x86_64: I: checking
ga-openmpi-static.x86_64: W: spelling-error %description -l en_US multi -> mulch, mufti
The value of this tag appears to be misspelled. Please double-check.

ga-openmpi-static.x86_64: I: checking-url http://www.emsl.pnl.gov/docs/global (timeout 10 seconds)
ga.spec: E: specfile-error doBuild: invalid option -- '-'
This error occurred when rpmlint used rpm to query the specfile.  The error is
output by rpm and the message should contain more information.

ga.spec: E: specfile-error error: Unknown option - in doBuild()
This error occurred when rpmlint used rpm to query the specfile.  The error is
output by rpm and the message should contain more information.

16 packages and 1 specfiles checked; 4 errors, 18 warnings.




The "doBuild()" option is unknown to rpmlint, of course. But it seems to work as expected, no matter.

The only-non-binary-in-usr-lib warnings refer to the config files which belong to the -devel-package. No problem, I had a quite similar problem recently in Erlang packages.

Besides that, we have some ignorable spelling errors.




---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    BSD
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    49f6b31082bd01efa5ff964665ebeebeaba7e3fb538ed164d173e9c5668641b7  ga-5-1-1.tgz
    49f6b31082bd01efa5ff964665ebeebeaba7e3fb538ed164d173e9c5668641b7  ga-5-1-1.tgz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[+] MUST: Static libraries must be in a -static package.
[+] MUST: Development files must be in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
Not fully applicable, the %{?_isa} tag is unneeded because the -common package is noarch.

[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[+] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

----------------

PACKAGE APPROVED

----------------
Comment 23 David Brown 2013-05-10 18:01:13 EDT
The funny thing about the spelling errors is I can't seem to find the string its complaining about. Its like some part of the build process put those in there.
Comment 24 David Brown 2013-05-14 11:56:39 EDT
New Package SCM Request
=======================
Package Name: ga
Short Description: Global Arrays Toolkit
Owners: dmlb2000
Branches: f19 f20 el5 el6
InitialCC:
Comment 25 Gwyn Ciesla 2013-05-14 12:14:01 EDT
Git done (by process-git-requests).
Comment 26 Fedora Update System 2013-05-14 14:14:07 EDT
ga-5.1.1-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ga-5.1.1-1.fc19
Comment 27 Fedora Update System 2013-05-14 18:35:29 EDT
ga-5.1.1-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/ga-5.1.1-2.el6
Comment 28 Fedora Update System 2013-05-15 12:43:32 EDT
Package ga-5.1.1-1.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing ga-5.1.1-1.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-8236/ga-5.1.1-1.fc19
then log in and leave karma (feedback).
Comment 29 Fedora Update System 2013-05-21 15:51:48 EDT
ga-5.1.1-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/ga-5.1.1-3.el6
Comment 30 Fedora Update System 2013-05-21 15:54:08 EDT
ga-5.1.1-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ga-5.1.1-3.fc19
Comment 31 Fedora Update System 2013-05-31 23:26:36 EDT
ga-5.1.1-3.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 32 Fedora Update System 2013-06-06 12:57:14 EDT
ga-5.1.1-3.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 33 David Brown 2014-07-07 23:44:39 EDT
Package Change Request
======================
Package Name: ga
New Branches: el7
Owners: dmlb2000

I'd like to start testing compatibility.

Note You need to log in before you can comment on or make changes to this bug.